require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ARCH_DESC_H)) {
    eval 'sub __ARCH_DESC_H () {1;}' unless defined(&__ARCH_DESC_H);
    require 'linux/threads.ph';
    require 'asm/ldt.ph';
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub __TSS_INDEX {
	    local($n) = @_;
    	    eval q((($n)*64));
	}' unless defined(&__TSS_INDEX);
	eval 'sub __LDT_INDEX {
	    local($n) = @_;
    	    eval q((($n)*64));
	}' unless defined(&__LDT_INDEX);
	eval("sub GATE_INTERRUPT () { 0xE; }") unless defined(&GATE_INTERRUPT);
	eval("sub GATE_TRAP () { 0xF; }") unless defined(&GATE_TRAP);
	eval("sub GATE_CALL () { 0xC; }") unless defined(&GATE_CALL);
	eval 'sub PTR_LOW {
	    local($x) = @_;
    	    eval q((($x) & 0xffff));
	}' unless defined(&PTR_LOW);
	eval 'sub PTR_MIDDLE {
	    local($x) = @_;
    	    eval q(((($x) >> 16) & 0xffff));
	}' unless defined(&PTR_MIDDLE);
	eval 'sub PTR_HIGH {
	    local($x) = @_;
    	    eval q((($x) >> 32));
	}' unless defined(&PTR_HIGH);
	eval("sub DESC_TSS () { 0x9; }") unless defined(&DESC_TSS);
	eval("sub DESC_LDT () { 0x2; }") unless defined(&DESC_LDT);
	eval 'sub __GDT_HEAD_SIZE () {64;}' unless defined(&__GDT_HEAD_SIZE);
	eval 'sub __CPU_DESC_INDEX {
	    local($x,$field) = @_;
    	    eval q((($x) * $sizeof{\'struct per_cpu_gdt\'} +  &offsetof(\'struct per_cpu_gdt\', $field) +  &__GDT_HEAD_SIZE));
	}' unless defined(&__CPU_DESC_INDEX);
	eval 'sub load_TR {
	    local($cpu) = @_;
    	    eval q( &asm  &volatile(\\"ltr %w0\\"::\\"r\\" ( &__CPU_DESC_INDEX($cpu,  &tss))););
	}' unless defined(&load_TR);
	eval 'sub __load_LDT {
	    local($cpu) = @_;
    	    eval q( &asm  &volatile(\\"lldt %w0\\"::\\"r\\" ( &__CPU_DESC_INDEX($cpu,  &ldt))););
	}' unless defined(&__load_LDT);
	eval 'sub clear_LDT {
	    local($n) = @_;
    	    eval q( &asm  &volatile(\\"lldt %w0\\"::\\"r\\" (0)));
	}' unless defined(&clear_LDT);
	eval 'sub copy_16byte {
	    local($dst,$src) = @_;
    	    eval q( &memcpy(($dst), ($src), 16));
	}' unless defined(&copy_16byte);
    }
}
1;
