require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_ASM_HW_IRQ_H)) {
    eval 'sub _ASM_HW_IRQ_H () {1;}' unless defined(&_ASM_HW_IRQ_H);
    unless(defined(&__ASSEMBLY__)) {
	require 'linux/config.ph';
	require 'linux/stddef.ph';
	require 'asm/atomic.ph';
	require 'asm/irq.ph';
    }
    eval 'sub FIRST_EXTERNAL_VECTOR () {0x20;}' unless defined(&FIRST_EXTERNAL_VECTOR);
    eval 'sub IA32_SYSCALL_VECTOR () {0x80;}' unless defined(&IA32_SYSCALL_VECTOR);
    eval 'sub SPURIOUS_APIC_VECTOR () {0xff;}' unless defined(&SPURIOUS_APIC_VECTOR);
    eval 'sub ERROR_APIC_VECTOR () {0xfe;}' unless defined(&ERROR_APIC_VECTOR);
    eval 'sub INVALIDATE_TLB_VECTOR () {0xfd;}' unless defined(&INVALIDATE_TLB_VECTOR);
    eval 'sub RESCHEDULE_VECTOR () {0xfc;}' unless defined(&RESCHEDULE_VECTOR);
    eval 'sub CALL_FUNCTION_VECTOR () {0xfb;}' unless defined(&CALL_FUNCTION_VECTOR);
    eval 'sub LOCAL_TIMER_VECTOR () {0xef;}' unless defined(&LOCAL_TIMER_VECTOR);
    eval 'sub FIRST_DEVICE_VECTOR () {0x31;}' unless defined(&FIRST_DEVICE_VECTOR);
    eval 'sub FIRST_SYSTEM_VECTOR () {0xef;}' unless defined(&FIRST_SYSTEM_VECTOR);
    unless(defined(&__ASSEMBLY__)) {
	eval 'sub IO_APIC_VECTOR {
	    local($irq) = @_;
    	    eval q( $irq_vector[$irq]);
	}' unless defined(&IO_APIC_VECTOR);
	eval 'sub IO_APIC_IRQ {
	    local($x) = @_;
    	    eval q(((($x) >= 16) || ((1<<($x)) &  &io_apic_irqs)));
	}' unless defined(&IO_APIC_IRQ);
	require 'asm/ptrace.ph';
	eval 'sub IRQ_NAME2 {
	    local($nr) = @_;
    	    eval q($nr &_interrupt( &void));
	}' unless defined(&IRQ_NAME2);
	eval 'sub IRQ_NAME {
	    local($nr) = @_;
    	    eval q( &IRQ_NAME2( &IRQ$nr));
	}' unless defined(&IRQ_NAME);
	eval 'sub BUILD_IRQ {
	    local($nr) = @_;
    	    eval q( &asmlinkage  &void  &IRQ_NAME($nr);  &__asm__( \\"\\\\n\\" &__ALIGN_STR \\"\\\\n\\"  &SYMBOL_NAME_STR( &IRQ) $nr \\"_interrupt:\\\\n\\\\t\\" \\"push $\\" $nr \\"-256 ; \\" \\"jmp common_interrupt\\"););
	}' unless defined(&BUILD_IRQ);
	if(defined(&CONFIG_SMP)) {
	} else {
	}
    }
}
1;
