require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&_X86_64_PAGE_H)) {
    eval 'sub _X86_64_PAGE_H () {1;}' unless defined(&_X86_64_PAGE_H);
    require 'linux/stringify.ph';
    eval 'sub PAGE_SHIFT () {12;}' unless defined(&PAGE_SHIFT);
    if(defined(&__ASSEMBLY__)) {
	eval 'sub PAGE_SIZE () {(0x1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    } else {
	eval 'sub PAGE_SIZE () {(1 <<  &PAGE_SHIFT);}' unless defined(&PAGE_SIZE);
    }
    eval 'sub PAGE_MASK () {(~( &PAGE_SIZE-1));}' unless defined(&PAGE_MASK);
    eval 'sub __PHYSICAL_MASK () {0xffffffffffff;}' unless defined(&__PHYSICAL_MASK);
    eval 'sub PHYSICAL_PAGE_MASK () {0xfffffffff000;}' unless defined(&PHYSICAL_PAGE_MASK);
    eval 'sub LARGE_PAGE_MASK () {(~( &LARGE_PAGE_SIZE-1));}' unless defined(&LARGE_PAGE_MASK);
    eval 'sub LARGE_PAGE_SIZE () {(1 <<  &PMD_SHIFT);}' unless defined(&LARGE_PAGE_SIZE);
    eval 'sub LARGE_PFN () {( &LARGE_PAGE_SIZE /  &PAGE_SIZE);}' unless defined(&LARGE_PFN);
    eval 'sub KERNEL_TEXT_SIZE () {(40*1024*1024);}' unless defined(&KERNEL_TEXT_SIZE);
    eval 'sub KERNEL_TEXT_START () {0xffffffff80000000;}' unless defined(&KERNEL_TEXT_START);
    eval 'sub THREAD_ORDER () {1;}' unless defined(&THREAD_ORDER);
    eval 'sub THREAD_SIZE () {(2* &PAGE_SIZE);}' unless defined(&THREAD_SIZE);
    eval 'sub INIT_TASK_SIZE () { &THREAD_SIZE;}' unless defined(&INIT_TASK_SIZE);
    eval 'sub CURRENT_MASK () {(~( &THREAD_SIZE-1));}' unless defined(&CURRENT_MASK);
    if(defined(&__KERNEL__)) {
	unless(defined(&__ASSEMBLY__)) {
	    eval 'sub clear_user_page {
	        local($page, $vaddr) = @_;
    		eval q( &clear_page($page));
	    }' unless defined(&clear_user_page);
	    eval 'sub copy_user_page {
	        local($to, $from, $vaddr) = @_;
    		eval q( &copy_page($to, $from));
	    }' unless defined(&copy_user_page);
	    eval 'sub PTE_MASK () { &PHYSICAL_PAGE_MASK;}' unless defined(&PTE_MASK);
	    eval 'sub pte_val {
	        local($x) = @_;
    		eval q((($x). &pte));
	    }' unless defined(&pte_val);
	    eval 'sub pmd_val {
	        local($x) = @_;
    		eval q((($x). &pmd));
	    }' unless defined(&pmd_val);
	    eval 'sub pgd_val {
	        local($x) = @_;
    		eval q((($x). &pgd));
	    }' unless defined(&pgd_val);
	    eval 'sub pml4_val {
	        local($x) = @_;
    		eval q((($x). &pml4));
	    }' unless defined(&pml4_val);
	    eval 'sub pgprot_val {
	        local($x) = @_;
    		eval q((($x). &pgprot));
	    }' unless defined(&pgprot_val);
	    eval 'sub __pte {
	        local($x) = @_;
    		eval q((( &pte_t) { ($x) } ));
	    }' unless defined(&__pte);
	    eval 'sub __pmd {
	        local($x) = @_;
    		eval q((( &pmd_t) { ($x) } ));
	    }' unless defined(&__pmd);
	    eval 'sub __pgd {
	        local($x) = @_;
    		eval q((( &pgd_t) { ($x) } ));
	    }' unless defined(&__pgd);
	    eval 'sub __level4 {
	        local($x) = @_;
    		eval q((( &level4_t) { ($x) } ));
	    }' unless defined(&__level4);
	    eval 'sub __pgprot {
	        local($x) = @_;
    		eval q((( &pgprot_t) { ($x) } ));
	    }' unless defined(&__pgprot);
	}
	eval 'sub PAGE_ALIGN {
	    local($addr) = @_;
    	    eval q(((($addr)+ &PAGE_SIZE-1) &PAGE_MASK));
	}' unless defined(&PAGE_ALIGN);
	eval 'sub __START_KERNEL () {0xffffffff80100000;}' unless defined(&__START_KERNEL);
	eval 'sub __START_KERNEL_map () {0xffffffff80000000;}' unless defined(&__START_KERNEL_map);
	eval 'sub __PAGE_OFFSET () {0x10000000000;}' unless defined(&__PAGE_OFFSET);
	unless(defined(&__ASSEMBLY__)) {
	    require 'linux/config.ph';
	    eval 'sub BUG () {
	        eval q( &asm  &volatile(\\"ud2 ; .quad %c1 ; .short %c0\\" :: \\"i\\"( &__LINE__), \\"i\\" ( &__stringify( &KBUILD_BASENAME))));
	    }' unless defined(&BUG);
	    eval 'sub HEADER_BUG () {
	        eval q( &asm  &volatile(\\"ud2 ; .quad %c1 ; .short %c0\\" :: \\"i\\"( &__LINE__), \\"i\\" ( &__stringify( &__FILE__))));
	    }' unless defined(&HEADER_BUG);
	    eval 'sub PAGE_BUG {
	        local($page) = @_;
    		eval q( &BUG());
	    }' unless defined(&PAGE_BUG);
	}
	eval 'sub PAGE_OFFSET () {( &__PAGE_OFFSET);}' unless defined(&PAGE_OFFSET);
	eval 'sub __pa {
	    local($x) = @_;
    	    eval q(((>= &__START_KERNEL_map)? -  &__START_KERNEL_map:($x) -  &PAGE_OFFSET));
	}' unless defined(&__pa);
	eval 'sub __pa_symbol {
	    local($x) = @_;
    	    eval q(({\'unsigned long v\';  &asm(\\"\\" : \\"=r\\" ( &v) : \\"0\\" ($x));  &v -  &__START_KERNEL_map; }));
	}' unless defined(&__pa_symbol);
	eval 'sub __pa_maybe_symbol {
	    local($x) = @_;
    	    eval q(({\'unsigned long v\';  &asm(\\"\\" : \\"=r\\" ( &v) : \\"0\\" ($x));  &__pa( &v); }));
	}' unless defined(&__pa_maybe_symbol);
	eval 'sub __va {
	    local($x) = @_;
    	    eval q(((($x)+ &PAGE_OFFSET)));
	}' unless defined(&__va);
	unless(defined(&CONFIG_DISCONTIGMEM)) {
	    eval 'sub virt_to_page {
	        local($kaddr) = @_;
    		eval q(( &mem_map + ( &__pa($kaddr) >>  &PAGE_SHIFT)));
	    }' unless defined(&virt_to_page);
	    eval 'sub pfn_to_page {
	        local($pfn) = @_;
    		eval q(( &mem_map + ($pfn)));
	    }' unless defined(&pfn_to_page);
	    eval 'sub page_to_pfn {
	        local($page) = @_;
    		eval q((($page) -  &mem_map));
	    }' unless defined(&page_to_pfn);
	    eval 'sub page_to_phys {
	        local($page) = @_;
    		eval q(((($page) -  &mem_map) <<  &PAGE_SHIFT));
	    }' unless defined(&page_to_phys);
	    eval 'sub VALID_PAGE {
	        local($page) = @_;
    		eval q(((($page) -  &mem_map) <  &max_mapnr));
	    }' unless defined(&VALID_PAGE);
	}
	eval 'sub phys_to_pfn {
	    local($phys) = @_;
    	    eval q((($phys) >>  &PAGE_SHIFT));
	}' unless defined(&phys_to_pfn);
	eval 'sub VM_DATA_DEFAULT_FLAGS () {( &VM_READ |  &VM_WRITE |  &VM_EXEC |  &VM_MAYREAD |  &VM_MAYWRITE |  &VM_MAYEXEC);}' unless defined(&VM_DATA_DEFAULT_FLAGS);
    }
}
1;
