require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ASM_X86_64_PROCESSOR_H)) {
    eval 'sub __ASM_X86_64_PROCESSOR_H () {1;}' unless defined(&__ASM_X86_64_PROCESSOR_H);
    require 'asm/segment.ph';
    require 'asm/page.ph';
    require 'asm/types.ph';
    require 'asm/sigcontext.ph';
    require 'asm/cpufeature.ph';
    require 'linux/config.ph';
    require 'linux/threads.ph';
    require 'asm/msr.ph';
    require 'asm/current.ph';
    require 'asm/system.ph';
    eval 'sub TF_MASK () {0x100;}' unless defined(&TF_MASK);
    eval 'sub IF_MASK () {0x200;}' unless defined(&IF_MASK);
    eval 'sub IOPL_MASK () {0x3000;}' unless defined(&IOPL_MASK);
    eval 'sub NT_MASK () {0x4000;}' unless defined(&NT_MASK);
    eval 'sub VM_MASK () {0x20000;}' unless defined(&VM_MASK);
    eval 'sub AC_MASK () {0x40000;}' unless defined(&AC_MASK);
    eval 'sub VIF_MASK () {0x80000;}' unless defined(&VIF_MASK);
    eval 'sub VIP_MASK () {0x100000;}' unless defined(&VIP_MASK);
    eval 'sub ID_MASK () {0x200000;}' unless defined(&ID_MASK);
    eval 'sub current_text_addr () {
        eval q(({  &void * &pc;  &asm  &volatile(\\"leaq 1f(%%rip),%0\\\\n1:\\":\\"=r\\"( &pc));  &pc; }));
    }' unless defined(&current_text_addr);
    eval 'sub X86_VENDOR_INTEL () {0;}' unless defined(&X86_VENDOR_INTEL);
    eval 'sub X86_VENDOR_CYRIX () {1;}' unless defined(&X86_VENDOR_CYRIX);
    eval 'sub X86_VENDOR_AMD () {2;}' unless defined(&X86_VENDOR_AMD);
    eval 'sub X86_VENDOR_UMC () {3;}' unless defined(&X86_VENDOR_UMC);
    eval 'sub X86_VENDOR_NEXGEN () {4;}' unless defined(&X86_VENDOR_NEXGEN);
    eval 'sub X86_VENDOR_CENTAUR () {5;}' unless defined(&X86_VENDOR_CENTAUR);
    eval 'sub X86_VENDOR_RISE () {6;}' unless defined(&X86_VENDOR_RISE);
    eval 'sub X86_VENDOR_TRANSMETA () {7;}' unless defined(&X86_VENDOR_TRANSMETA);
    eval 'sub X86_VENDOR_UNKNOWN () {0xff;}' unless defined(&X86_VENDOR_UNKNOWN);
    if(defined(&CONFIG_SMP)) {
	eval 'sub current_cpu_data () { $cpu_data[ &smp_processor_id()];}' unless defined(&current_cpu_data);
    } else {
	eval 'sub cpu_data () {( &boot_cpu_data);}' unless defined(&cpu_data);
	eval 'sub current_cpu_data () { &boot_cpu_data;}' unless defined(&current_cpu_data);
    }
    eval 'sub cpu_has_pge () {1;}' unless defined(&cpu_has_pge);
    eval 'sub cpu_has_pse () {1;}' unless defined(&cpu_has_pse);
    eval 'sub cpu_has_pae () {1;}' unless defined(&cpu_has_pae);
    eval 'sub cpu_has_tsc () {1;}' unless defined(&cpu_has_tsc);
    eval 'sub cpu_has_de () {1;}' unless defined(&cpu_has_de);
    eval 'sub cpu_has_vme () {1;}' unless defined(&cpu_has_vme);
    eval 'sub cpu_has_fxsr () {1;}' unless defined(&cpu_has_fxsr);
    eval 'sub cpu_has_xmm () {1;}' unless defined(&cpu_has_xmm);
    eval 'sub cpu_has_apic () {1;}' unless defined(&cpu_has_apic);
    eval 'sub X86_EFLAGS_CF () {0x1;}' unless defined(&X86_EFLAGS_CF);
    eval 'sub X86_EFLAGS_PF () {0x4;}' unless defined(&X86_EFLAGS_PF);
    eval 'sub X86_EFLAGS_AF () {0x10;}' unless defined(&X86_EFLAGS_AF);
    eval 'sub X86_EFLAGS_ZF () {0x40;}' unless defined(&X86_EFLAGS_ZF);
    eval 'sub X86_EFLAGS_SF () {0x80;}' unless defined(&X86_EFLAGS_SF);
    eval 'sub X86_EFLAGS_TF () {0x100;}' unless defined(&X86_EFLAGS_TF);
    eval 'sub X86_EFLAGS_IF () {0x200;}' unless defined(&X86_EFLAGS_IF);
    eval 'sub X86_EFLAGS_DF () {0x400;}' unless defined(&X86_EFLAGS_DF);
    eval 'sub X86_EFLAGS_OF () {0x800;}' unless defined(&X86_EFLAGS_OF);
    eval 'sub X86_EFLAGS_IOPL () {0x3000;}' unless defined(&X86_EFLAGS_IOPL);
    eval 'sub X86_EFLAGS_NT () {0x4000;}' unless defined(&X86_EFLAGS_NT);
    eval 'sub X86_EFLAGS_RF () {0x10000;}' unless defined(&X86_EFLAGS_RF);
    eval 'sub X86_EFLAGS_VM () {0x20000;}' unless defined(&X86_EFLAGS_VM);
    eval 'sub X86_EFLAGS_AC () {0x40000;}' unless defined(&X86_EFLAGS_AC);
    eval 'sub X86_EFLAGS_VIF () {0x80000;}' unless defined(&X86_EFLAGS_VIF);
    eval 'sub X86_EFLAGS_VIP () {0x100000;}' unless defined(&X86_EFLAGS_VIP);
    eval 'sub X86_EFLAGS_ID () {0x200000;}' unless defined(&X86_EFLAGS_ID);
1;
